<a id="types-aiobotocore-xray"></a>

# types-aiobotocore-xray

[![PyPI - types-aiobotocore-xray](https://img.shields.io/pypi/v/types-aiobotocore-xray.svg?color=blue)](https://pypi.org/project/types-aiobotocore-xray)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-xray.svg?color=blue)](https://pypi.org/project/types-aiobotocore-xray)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-xray?color=blue)](https://pypistats.org/packages/types-aiobotocore-xray)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.XRay 2.4.2](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/xray.html#XRay)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.13.0](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-xray docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_xray/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-xray](#types-aiobotocore-xray)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `XRay` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[xray]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[xray]'


# standalone installation
python -m pip install types-aiobotocore-xray
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-xray
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[xray]` in your environment:

```bash
python -m pip install 'types-aiobotocore[xray]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[xray]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[xray]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[xray]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[xray]` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[xray]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[xray]` in your environment:

```bash
python -m pip install 'types-aiobotocore[xray]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[xray]` in your environment:

```bash
python -m pip install 'types-aiobotocore[xray]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`XRayClient` provides annotations for `session.create_client("xray")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_xray import XRayClient

session = get_session()
async with session.create_client("xray") as client:
    client: XRayClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_xray.paginator` module contains type annotations for all
paginators.

```python
from aiobotocore.session import get_session

from types_aiobotocore_xray import XRayClient
from types_aiobotocore_xray.paginator import (
    BatchGetTracesPaginator,
    GetGroupsPaginator,
    GetSamplingRulesPaginator,
    GetSamplingStatisticSummariesPaginator,
    GetServiceGraphPaginator,
    GetTimeSeriesServiceStatisticsPaginator,
    GetTraceGraphPaginator,
    GetTraceSummariesPaginator,
)

session = get_session()
async with session.create_client("xray") as client:
    client: XRayClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    batch_get_traces_paginator: BatchGetTracesPaginator = client.get_paginator("batch_get_traces")
    get_groups_paginator: GetGroupsPaginator = client.get_paginator("get_groups")
    get_sampling_rules_paginator: GetSamplingRulesPaginator = client.get_paginator(
        "get_sampling_rules"
    )
    get_sampling_statistic_summaries_paginator: GetSamplingStatisticSummariesPaginator = (
        client.get_paginator("get_sampling_statistic_summaries")
    )
    get_service_graph_paginator: GetServiceGraphPaginator = client.get_paginator(
        "get_service_graph"
    )
    get_time_series_service_statistics_paginator: GetTimeSeriesServiceStatisticsPaginator = (
        client.get_paginator("get_time_series_service_statistics")
    )
    get_trace_graph_paginator: GetTraceGraphPaginator = client.get_paginator("get_trace_graph")
    get_trace_summaries_paginator: GetTraceSummariesPaginator = client.get_paginator(
        "get_trace_summaries"
    )
```

<a id="literals"></a>

### Literals

`types_aiobotocore_xray.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from types_aiobotocore_xray.literals import (
    BatchGetTracesPaginatorName,
    EncryptionStatusType,
    EncryptionTypeType,
    GetGroupsPaginatorName,
    GetSamplingRulesPaginatorName,
    GetSamplingStatisticSummariesPaginatorName,
    GetServiceGraphPaginatorName,
    GetTimeSeriesServiceStatisticsPaginatorName,
    GetTraceGraphPaginatorName,
    GetTraceSummariesPaginatorName,
    InsightCategoryType,
    InsightStateType,
    SamplingStrategyNameType,
    TimeRangeTypeType,
    XRayServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)


def check_value(value: BatchGetTracesPaginatorName) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_xray.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_xray.type_defs import (
    AliasTypeDef,
    AnnotationValueTypeDef,
    ServiceIdTypeDef,
    AvailabilityZoneDetailTypeDef,
    BackendConnectionErrorsTypeDef,
    PaginatorConfigTypeDef,
    BatchGetTracesRequestRequestTypeDef,
    ResponseMetadataTypeDef,
    InsightsConfigurationTypeDef,
    TagTypeDef,
    SamplingRuleTypeDef,
    DeleteGroupRequestRequestTypeDef,
    DeleteSamplingRuleRequestRequestTypeDef,
    ErrorStatisticsTypeDef,
    FaultStatisticsTypeDef,
    HistogramEntryTypeDef,
    EncryptionConfigTypeDef,
    RootCauseExceptionTypeDef,
    ForecastStatisticsTypeDef,
    GetGroupRequestRequestTypeDef,
    GetGroupsRequestRequestTypeDef,
    GetInsightEventsRequestRequestTypeDef,
    GetInsightImpactGraphRequestRequestTypeDef,
    GetInsightRequestRequestTypeDef,
    GetInsightSummariesRequestRequestTypeDef,
    GetSamplingRulesRequestRequestTypeDef,
    GetSamplingStatisticSummariesRequestRequestTypeDef,
    SamplingStatisticSummaryTypeDef,
    SamplingStatisticsDocumentTypeDef,
    SamplingTargetDocumentTypeDef,
    UnprocessedStatisticsTypeDef,
    GetServiceGraphRequestRequestTypeDef,
    GetTimeSeriesServiceStatisticsRequestRequestTypeDef,
    GetTraceGraphRequestRequestTypeDef,
    SamplingStrategyTypeDef,
    HttpTypeDef,
    RequestImpactStatisticsTypeDef,
    InsightImpactGraphEdgeTypeDef,
    InstanceIdDetailTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    PutEncryptionConfigRequestRequestTypeDef,
    PutTraceSegmentsRequestRequestTypeDef,
    UnprocessedTraceSegmentTypeDef,
    ResourceARNDetailTypeDef,
    ResponseTimeRootCauseEntityTypeDef,
    SamplingRuleUpdateTypeDef,
    SegmentTypeDef,
    UntagResourceRequestRequestTypeDef,
    AnomalousServiceTypeDef,
    TraceUserTypeDef,
    ValueWithServiceIdsTypeDef,
    TelemetryRecordTypeDef,
    BatchGetTracesRequestBatchGetTracesPaginateTypeDef,
    GetGroupsRequestGetGroupsPaginateTypeDef,
    GetSamplingRulesRequestGetSamplingRulesPaginateTypeDef,
    GetSamplingStatisticSummariesRequestGetSamplingStatisticSummariesPaginateTypeDef,
    GetServiceGraphRequestGetServiceGraphPaginateTypeDef,
    GetTimeSeriesServiceStatisticsRequestGetTimeSeriesServiceStatisticsPaginateTypeDef,
    GetTraceGraphRequestGetTraceGraphPaginateTypeDef,
    GroupSummaryTypeDef,
    GroupTypeDef,
    UpdateGroupRequestRequestTypeDef,
    CreateGroupRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    TagResourceRequestRequestTypeDef,
    CreateSamplingRuleRequestRequestTypeDef,
    SamplingRuleRecordTypeDef,
    EdgeStatisticsTypeDef,
    ServiceStatisticsTypeDef,
    GetEncryptionConfigResultTypeDef,
    PutEncryptionConfigResultTypeDef,
    ErrorRootCauseEntityTypeDef,
    FaultRootCauseEntityTypeDef,
    GetSamplingStatisticSummariesResultTypeDef,
    GetSamplingTargetsRequestRequestTypeDef,
    GetSamplingTargetsResultTypeDef,
    GetTraceSummariesRequestGetTraceSummariesPaginateTypeDef,
    GetTraceSummariesRequestRequestTypeDef,
    InsightImpactGraphServiceTypeDef,
    PutTraceSegmentsResultTypeDef,
    ResponseTimeRootCauseServiceTypeDef,
    UpdateSamplingRuleRequestRequestTypeDef,
    TraceTypeDef,
    InsightEventTypeDef,
    InsightSummaryTypeDef,
    InsightTypeDef,
    PutTelemetryRecordsRequestRequestTypeDef,
    GetGroupsResultTypeDef,
    CreateGroupResultTypeDef,
    GetGroupResultTypeDef,
    UpdateGroupResultTypeDef,
    CreateSamplingRuleResultTypeDef,
    DeleteSamplingRuleResultTypeDef,
    GetSamplingRulesResultTypeDef,
    UpdateSamplingRuleResultTypeDef,
    EdgeTypeDef,
    TimeSeriesServiceStatisticsTypeDef,
    ErrorRootCauseServiceTypeDef,
    FaultRootCauseServiceTypeDef,
    GetInsightImpactGraphResultTypeDef,
    ResponseTimeRootCauseTypeDef,
    BatchGetTracesResultTypeDef,
    GetInsightEventsResultTypeDef,
    GetInsightSummariesResultTypeDef,
    GetInsightResultTypeDef,
    ServiceTypeDef,
    GetTimeSeriesServiceStatisticsResultTypeDef,
    ErrorRootCauseTypeDef,
    FaultRootCauseTypeDef,
    GetServiceGraphResultTypeDef,
    GetTraceGraphResultTypeDef,
    TraceSummaryTypeDef,
    GetTraceSummariesResultTypeDef,
)


def get_structure() -> AliasTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers a drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from the documentation (blame `botocore` docs if types
  are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore` and `aiobotocore` libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.session` calls
- Auto discovery of types for `session.client` and `session.session` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-xray` version is the same as related `aiobotocore` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_xray/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
